﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=SMM_Example2.zip

Sub Class_Globals
	Private Root As B4XView 'ignore
	Private CustomListView1 As CustomListView
	Private PCLV As PreoptimizedCLV
	Private xui As XUI
	Type MyImageData (IndexOfFirstImage As Int)
	Private MediaManager As SimpleMediaManager
	
	Private csvList As List
End Sub

Public Sub Initialize
	
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	'Stress test this example in RELEASE mode!
	B4XPages.SetTitle(Me, "SMM Example #2")
	Root = Root1
	Root.LoadLayout("1")
	MediaManager.Initialize
	'Download the csv file from the website
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download("https://www.d99p.cn/images/mycsvfile.csv")	
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		If File.Exists(File.DirInternal, "mycsvfile.csv") Then
			File.Delete(File.DirInternal, "mycsvfile.csv")	
		End If
		Dim in As InputStream
		in = j.GetInputStream
		Dim out As OutputStream = File.OpenOutput(File.DirInternal, "mycsvfile.csv", False)
		File.Copy2(in, out)
		out.Close 
		in.Close
	Else
		File.Copy(File.DirAssets,"mycsvfile.csv",File.DirInternal,"mycsvfile.csv")
	End If
	j.Release
	'插入读取表格内容部分代码
	csvList.Initialize
	Dim InputStream1 As InputStream
	InputStream1 = File.OpenInput(File.DirInternal, "mycsvfile.csv")
	Dim TextReader1 As TextReader
	TextReader1.Initialize(InputStream1)
	Dim Line As String
	Do While TextReader1.Ready = True
		Line = TextReader1.ReadLine
		Dim Fields() As String
		Fields = Regex.Split(",", Line)
		Dim level As String = Fields(0)
		Dim url As String = Fields(1)
		Dim name As String = Fields(2)
		Dim image As String = Fields(3)
		Dim item As Map
		item.Initialize
		item.Put("level", level)
		item.Put("url", url)
		item.Put("name", name)
		item.Put("image", image)
		csvList.Add(item)
	Loop
	TextReader1.Close
	
	PCLV.Initialize(Me, "PCLV", CustomListView1)
	Dim height As Int
	If xui.IsB4J Then height = 200dip Else height = 150dip
	For i = 0 To csvList.Size - 1	'For i = 1 To 60'0 Step 4
		PCLV.AddItem(height, xui.Color_White, CreateMyImageData(i))
	Next
	PCLV.ShowScrollBar = False 'no fast scrolling
	PCLV.ExtraItems = 3
	PCLV.Commit
End Sub

Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PCLV.VisibleRangeChanged(FirstIndex, LastIndex)
		If i>=LastIndex+1 Then Exit
		Dim item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim pnl As B4XView = xui.CreatePanel("")
		item.Panel.AddView(pnl, 0, 0, item.Panel.Width, item.Panel.Height)
		Dim data As MyImageData = item.Value
		'Create the item layout
		pnl.LoadLayout("item")
		Dim itmap As Map
		itmap = csvList.Get(i+1)
		Dim imgurl As String
		imgurl=itmap.Get("image")
		pnl.GetView(0).GetView(1).Text = itmap.Get("url")'data.IndexOfFirstImage '+ x
		MediaManager.SetMedia(pnl.GetView(0).GetView(0),imgurl)'	MediaManager.SetMedia(pnl.GetView(0).GetView(0), $"https://picsum.photos/id/${data.IndexOfFirstImage}/500/100.jpg"$)

	Next
	'The purpose of this call is to find panels that are no longer in the views tree and cancel any ongoing request that is no longer relevant.
	'It also happens automatically from time to time but in this case, as many requests are sent frequently, it is better to force it to trim the cache.
	'Note that you need to add HU2_PUBLIC to the build configuration.
	MediaManager.TrimMediaCache
End Sub



Public Sub CreateMyImageData (IndexOfFirstImage As Int) As MyImageData
	Dim t1 As MyImageData
	t1.Initialize
	t1.IndexOfFirstImage = IndexOfFirstImage
	Return t1
End Sub